# PhasicFlow: PeakableRegion< GeomType > Class Template Reference
PhasicFlow is an open-source parallel DEM (discrete element method) package for simulating granular flow. It is developed in C++ and can be exectued on both GPU (like CUDA) and CPU.

PeakableRegion< GeomType > Class Template Reference
Inheritance diagram for PeakableRegion< GeomType >:
[legend]
Collaboration diagram for PeakableRegion< GeomType >:
[legend]

## Public Types

using | RegionType = geometricRegion< GeomType >
using | GeometryType = typename RegionType::GeometryType

## Public Member Functions

| TypeInfoTemplate11 ("peakable", GeometryType)
| PeakableRegion (const word &type, const dictionary &dict)
| add_vCtor (peakableRegion, PeakableRegion, word)
virtual uniquePtr< peakableRegion > | clone () const override
virtual peakableRegion * | clonePtr () const override
virtual | ~PeakableRegion ()=default
bool | isInside (const realx3 &point) const override
realx3 | peek () const override
const realx3 & | minPoint () const override
const realx3 & | maxPoint () const override
virtual bool | read (const dictionary &dict) override
virtual bool | write (dictionary &dict) const override
Public Member Functions inherited from peakableRegion
| TypeInfo ("peakableRegion")
| peakableRegion (const word &type, const dictionary &dict)
| create_vCtor (peakableRegion, word,(const word &type, const dictionary &dict),(type, dict))
virtual | ~peakableRegion ()=default

## Private Attributes

RegionType | region_

## Additional Inherited Members

Static Public Member Functions inherited from peakableRegion
static uniquePtr< peakableRegion > | create (const word &type, const dictionary &dict)

## Detailed Description

### template<typename GeomType>
class pFlow::PeakableRegion< GeomType >

Definition at line 32 of file PeakableRegion.hpp.

## Member Typedef Documentation

## RegionType

using RegionType = geometricRegion<GeomType>

Definition at line 36 of file PeakableRegion.hpp.

## GeometryType

using GeometryType = typename RegionType::GeometryType

Definition at line 38 of file PeakableRegion.hpp.

## Constructor & Destructor Documentation

## PeakableRegion()

PeakableRegion | ( | const word & | type,
|  | const dictionary & | dict
| ) |  |

Definition at line 24 of file PeakableRegion.cpp.

## ~PeakableRegion()

virtual ~PeakableRegion | ( |  | ) |

virtualdefault

## Member Function Documentation

## TypeInfoTemplate11()

TypeInfoTemplate11 | ( | "peakable" | ,
|  | GeometryType |
| ) |  |

## add_vCtor()

add_vCtor | ( | peakableRegion | ,
|  | PeakableRegion< GeomType > | ,
|  | word |
| ) |  |

## clone()

virtual uniquePtr<peakableRegion> clone | ( |  | ) | const

inlineoverridevirtual

Implements peakableRegion.

Definition at line 54 of file PeakableRegion.hpp.

## clonePtr()

virtual peakableRegion* clonePtr | ( |  | ) | const

inlineoverridevirtual

Implements peakableRegion.

Definition at line 59 of file PeakableRegion.hpp.

## isInside()

bool isInside | ( | const realx3 & | point | ) | const

overridevirtual

Implements peakableRegion.

Definition at line 37 of file PeakableRegion.cpp.

## peek()

pFlow::realx3 peek

overridevirtual

Implements peakableRegion.

Definition at line 46 of file PeakableRegion.cpp.

## minPoint()

const realx3& minPoint | ( |  | ) | const

inlineoverridevirtual

Implements peakableRegion.

Definition at line 72 of file PeakableRegion.hpp.

References geometricRegion< GeomType >::minPoint(), and PeakableRegion< GeomType >::region_.

Here is the call graph for this function:

## maxPoint()

const realx3& maxPoint | ( |  | ) | const

inlineoverridevirtual

Implements peakableRegion.

Definition at line 77 of file PeakableRegion.hpp.

References geometricRegion< GeomType >::maxPoint(), and PeakableRegion< GeomType >::region_.

Here is the call graph for this function:

## read()

bool read | ( | const dictionary & | dict | ) |

overridevirtual

Implements peakableRegion.

Definition at line 52 of file PeakableRegion.cpp.

## write()

bool write | ( | dictionary & | dict | ) | const

overridevirtual

Implements peakableRegion.

Definition at line 58 of file PeakableRegion.cpp.

## Member Data Documentation

## region_

RegionType region_

private

Definition at line 42 of file PeakableRegion.hpp.

Referenced by PeakableRegion< GeomType >::maxPoint(), and PeakableRegion< GeomType >::minPoint().

The documentation for this class was generated from the following files:

- src/phasicFlow/structuredData/peakableRegion/PeakableRegion/PeakableRegion.hpp
- src/phasicFlow/structuredData/peakableRegion/PeakableRegion/PeakableRegion.cpp